'     .
'  PIC16F876
'  ..
'24.01.07

		
        Set_Defaults PROTON_4			
        Device 16F876
		
		TRISB = %00001111
		PORTB_PULLUPS = ON		
		ALL_DIGITAL = TRUE        

		DECLARE LCD_TYPE 0
		DECLARE LCD_DTPIN PORTB.4	
		DECLARE LCD_ENPIN PORTA.1
		DECLARE LCD_RSPIN PORTA.0 
		DECLARE LCD_INTERFACE 4
		DECLARE LCD_LINES 2
		
		Dim BUF1 as Byte	' 			
		Dim BUF2 as Byte	' 			
		Dim BUF3 as Byte	' +			
		Dim BUF4 as Byte    ' -   
		Dim Duty as	WORD		
		Dim displey_text as Byte
		Dim State as Byte
		State = 0
				
		Symbol SW1	= PORTB.0
		Symbol SW2	= PORTB.1
		Symbol SW3	= PORTB.2
		Symbol SW4	= PORTB.3
		
		TRISC.2 = 0					' Set PORTC.2 (CCP1) to output
		CCP1CON = %00000000			' Set CCP1 to PWM 
		T2CON = %00000101			' Turn on Timer2, Prescale=4
		PR2 = 249					' Set PR2 to get 1KHz out	
		
Main:	
		call opros_key
		displey_text = Duty / 10
		LCDOUT $FE, 2, "HA",$A1,"P",$A9,"3KA: ",dec displey_text, " %      "
		
		CCP1CON.4 = Duty.0			
		CCP1CON.5 = Duty.1			
		CCPR1L = Duty >> 2

		Delayms 10					
	
		Goto Main					
		
opros_key:	
	
	Chk1:	
		Button SW1,0,25,5,BUF1,0,Chk2	
		Duty = 10
		CCP1CON = %00001100		
		State.0	= 1
			
	Chk2:
		Button SW2,0,25,5,BUF2,0,Chk3
		CCP1CON = %00000000
		PORTC.2 = 0
		State.0	= 0
	
	Chk3:
		IF State.0 == 0 THEN
		LCDOUT $FE, 2, "     CTAPT ?    "
		GOTO Chk1
		ENDIF		
		
		Button SW3,0,25,2,BUF3,0,Chk4	
		IF Duty < 1000 THEN Duty = Duty	+ 10
				
	Chk4:
		Button SW4,0,25,2,BUF4,0,Chk5	
		IF Duty > 0 THEN Duty = Duty	- 10				


		RETURN	
	Chk5:
			
	RETURN

	END